import java.util.*;

public class SeniorMinimum {
	
	private static enum ClassStanding {
	    FRESHMAN, SOPHOMORE, JUNIOR, SENIOR
	}

	private static class Student {
		
		Student(int age, ClassStanding year) {
			this.age = age;
			this.year = year;
		}

	    int age;
	    ClassStanding year;
	    
	}

	public static void main(String[] args) {
		
		List<Student> students = 
			Arrays.asList(
	            new Student(20, ClassStanding.FRESHMAN),
	            new Student(17, ClassStanding.SENIOR),
	            new Student(23, ClassStanding.SOPHOMORE),
	            new Student(22, ClassStanding.SENIOR),
	            new Student(19, ClassStanding.JUNIOR),
	            new Student(22, ClassStanding.SENIOR));

		// in-class solution
		int min = students.stream()
				          .filter(s -> s.year == ClassStanding.SENIOR)
				          .reduce((s1, s2) -> s1.age < s2.age ? s1 : s2)
				          .get().age;
		System.out.println("The minimum age of seniors is " + min + ".");
		
		// alternate solution
		OptionalInt optMin = students.stream()
				                     .filter(s -> s.year == ClassStanding.SENIOR)
				                     .mapToInt(s -> s.age)
				                     .reduce(Integer::min);
		                           //.min();
		System.out.println("The minimum age of seniors is " + optMin.getAsInt() + ".");
	}

}
